package sun.tools.tree;

import java.util.Hashtable;
import sun.tools.asm.Assembler;
import sun.tools.java.CompilerError;
import sun.tools.java.Environment;
import sun.tools.java.Type;

public class ArrayExpression extends NaryExpression {
   public ArrayExpression(int var1, Expression[] var2) {
      super(57, var1, Type.tError, (Expression)null, var2);
   }

   public Vset checkValue(Environment var1, Context var2, Vset var3, Hashtable var4) {
      var1.error(super.where, "invalid.array.expr");
      return var3;
   }

   public Vset checkInitializer(Environment var1, Context var2, Vset var3, Type var4, Hashtable var5) {
      if (!var4.isType(9)) {
         if (!var4.isType(13)) {
            var1.error(super.where, "invalid.array.init", var4);
         }

         return var3;
      } else {
         super.type = var4;
         var4 = var4.getElementType();

         for(int var6 = 0; var6 < super.args.length; ++var6) {
            var3 = super.args[var6].checkInitializer(var1, var2, var3, var4, var5);
            super.args[var6] = ((Node)this).convert(var1, var2, var4, super.args[var6]);
         }

         return var3;
      }
   }

   public Expression inline(Environment var1, Context var2) {
      Object var3 = null;

      for(int var4 = 0; var4 < super.args.length; ++var4) {
         super.args[var4] = super.args[var4].inline(var1, var2);
         if (super.args[var4] != null) {
            var3 = var3 == null ? super.args[var4] : new CommaExpression(super.where, (Expression)var3, super.args[var4]);
         }
      }

      return (Expression)var3;
   }

   public Expression inlineValue(Environment var1, Context var2) {
      for(int var3 = 0; var3 < super.args.length; ++var3) {
         super.args[var3] = super.args[var3].inlineValue(var1, var2);
      }

      return this;
   }

   public void codeValue(Environment var1, Context var2, Assembler var3) {
      var3.add(super.where, 18, new Integer(super.args.length));
      switch (super.type.getElementType().getTypeCode()) {
         case 0:
            var3.add(super.where, 188, new Integer(4));
            break;
         case 1:
            var3.add(super.where, 188, new Integer(8));
            break;
         case 2:
            var3.add(super.where, 188, new Integer(5));
            break;
         case 3:
            var3.add(super.where, 188, new Integer(9));
            break;
         case 4:
            var3.add(super.where, 188, new Integer(10));
            break;
         case 5:
            var3.add(super.where, 188, new Integer(11));
            break;
         case 6:
            var3.add(super.where, 188, new Integer(6));
            break;
         case 7:
            var3.add(super.where, 188, new Integer(7));
            break;
         case 8:
         default:
            throw new CompilerError("codeValue");
         case 9:
            var3.add(super.where, 189, super.type.getElementType());
            break;
         case 10:
            var3.add(super.where, 189, var1.getClassDeclaration(super.type.getElementType()));
      }

      for(int var4 = 0; var4 < super.args.length; ++var4) {
         var3.add(super.where, 89);
         var3.add(super.where, 18, new Integer(var4));
         super.args[var4].codeValue(var1, var2, var3);
         switch (super.type.getElementType().getTypeCode()) {
            case 0:
            case 1:
               var3.add(super.where, 84);
               break;
            case 2:
               var3.add(super.where, 85);
               break;
            case 3:
               var3.add(super.where, 86);
               break;
            default:
               var3.add(super.where, 79 + super.type.getElementType().getTypeCodeOffset());
         }
      }

   }
}
