package sun.tools.tree;

import sun.tools.asm.Assembler;
import sun.tools.java.Environment;
import sun.tools.java.Type;

public abstract class BinaryBitExpression extends BinaryExpression {
   public BinaryBitExpression(int var1, int var2, Expression var3, Expression var4) {
      super(var1, var2, var3.type, var3, var4);
   }

   void selectType(Environment var1, Context var2, int var3) {
      if ((var3 & 1) != 0) {
         super.type = Type.tBoolean;
      } else if ((var3 & 32) != 0) {
         super.type = Type.tLong;
      } else {
         super.type = Type.tInt;
      }

      super.left = ((Node)this).convert(var1, var2, super.type, super.left);
      super.right = ((Node)this).convert(var1, var2, super.type, super.right);
   }

   public void codeValue(Environment var1, Context var2, Assembler var3) {
      super.left.codeValue(var1, var2, var3);
      super.right.codeValue(var1, var2, var3);
      ((BinaryExpression)this).codeOperation(var1, var2, var3);
   }
}
