package sun.tools.tree;

import sun.tools.asm.Assembler;
import sun.tools.java.Environment;

public class BitAndExpression extends BinaryBitExpression {
   public BitAndExpression(int var1, Expression var2, Expression var3) {
      super(18, var1, var2, var3);
   }

   Expression eval(boolean var1, boolean var2) {
      return new BooleanExpression(super.where, var1 & var2);
   }

   Expression eval(int var1, int var2) {
      return new IntExpression(super.where, var1 & var2);
   }

   Expression eval(long var1, long var3) {
      return new LongExpression(super.where, var1 & var3);
   }

   Expression simplify() {
      if (super.left.equals(true)) {
         return super.right;
      } else if (super.right.equals(true)) {
         return super.left;
      } else if (!super.left.equals(false) && !super.left.equals(0)) {
         return (Expression)(!super.right.equals(false) && !super.right.equals(0) ? this : (new CommaExpression(super.where, super.left, super.right)).simplify());
      } else {
         return (new CommaExpression(super.where, super.right, super.left)).simplify();
      }
   }

   void codeOperation(Environment var1, Context var2, Assembler var3) {
      var3.add(super.where, 126 + super.type.getTypeCodeOffset());
   }
}
