package sun.tools.tree;

import java.io.PrintStream;
import java.util.Hashtable;
import sun.tools.asm.Assembler;
import sun.tools.java.Environment;
import sun.tools.java.Identifier;
import sun.tools.java.Type;

public class BreakStatement extends Statement {
   Identifier lbl;

   public BreakStatement(int var1, Identifier var2) {
      super(98, var1);
      this.lbl = var2;
   }

   Vset check(Environment var1, Context var2, Vset var3, Hashtable var4) {
      ((Statement)this).reach(var1, var3);
      CheckContext var5 = (CheckContext)(new CheckContext(var2, this)).getBreakContext(this.lbl);
      if (var5 != null) {
         if (var5.frameNumber != var2.frameNumber) {
            var1.error(super.where, "branch.to.uplevel", this.lbl);
         }

         var5.vsBreak = var5.vsBreak.join(var3);
      } else if (this.lbl != null) {
         var1.error(super.where, "label.not.found", this.lbl);
      } else {
         var1.error(super.where, "invalid.break");
      }

      return Statement.DEAD_END;
   }

   public int costInline(int var1, Environment var2, Context var3) {
      return 1;
   }

   public void code(Environment var1, Context var2, Assembler var3) {
      CodeContext var4 = new CodeContext(var2, this);
      CodeContext var5 = (CodeContext)((Context)var4).getBreakContext(this.lbl);
      ((Statement)this).codeFinally(var1, var2, var3, var5, (Type)null);
      var3.add(super.where, 167, var5.breakLabel);
      var3.add(var4.breakLabel);
   }

   public void print(PrintStream var1, int var2) {
      super.print(var1, var2);
      var1.print("break");
      if (this.lbl != null) {
         var1.print(" " + this.lbl);
      }

      var1.print(";");
   }
}
