package sun.tools.tree;

import java.io.PrintStream;
import java.util.Hashtable;
import sun.tools.java.ClassDefinition;
import sun.tools.java.ClassNotFound;
import sun.tools.java.Constants;
import sun.tools.java.Environment;
import sun.tools.java.Type;

public class CastExpression extends BinaryExpression {
   public CastExpression(int var1, Expression var2, Expression var3) {
      super(34, var1, var2.type, var2, var3);
   }

   public Vset checkValue(Environment var1, Context var2, Vset var3, Hashtable var4) {
      super.type = super.left.toType(var1, var2);
      var3 = super.right.checkValue(var1, var2, var3, var4);
      if (!super.type.isType(13) && !super.right.type.isType(13)) {
         if (super.type.equals(super.right.type)) {
            return var3;
         } else {
            try {
               if (var1.explicitCast(super.right.type, super.type)) {
                  super.right = new ConvertExpression(super.where, super.type, super.right);
                  return var3;
               }
            } catch (ClassNotFound var6) {
               var1.error(super.where, "class.not.found", var6.name, Constants.opNames[super.op]);
            }

            var1.error(super.where, "invalid.cast", super.right.type, super.type);
            return var3;
         }
      } else {
         return var3;
      }
   }

   public boolean isConstant() {
      return super.type.inMask(1792) && !super.type.equals(Type.tString) ? false : super.right.isConstant();
   }

   public Expression inline(Environment var1, Context var2) {
      return super.right.inline(var1, var2);
   }

   public Expression inlineValue(Environment var1, Context var2) {
      return super.right.inlineValue(var1, var2);
   }

   public int costInline(int var1, Environment var2, Context var3) {
      if (var3 == null) {
         return 1 + super.right.costInline(var1, var2, var3);
      } else {
         ClassDefinition var4 = var3.field.getClassDefinition();

         try {
            if (super.left.type.isType(9) || var4.canAccess(var2, var2.getClassDeclaration(super.left.type))) {
               return 1 + super.right.costInline(var1, var2, var3);
            }
         } catch (ClassNotFound var5) {
         }

         return var1;
      }
   }

   public void print(PrintStream var1) {
      var1.print("(" + Constants.opNames[super.op] + " ");
      if (super.type.isType(13)) {
         super.left.print(var1);
      } else {
         var1.print(super.type);
      }

      var1.print(" ");
      super.right.print(var1);
      var1.print(")");
   }
}
