package sun.tools.tree;

import java.util.Hashtable;
import sun.tools.asm.Assembler;
import sun.tools.java.Environment;
import sun.tools.java.Type;

public class CommaExpression extends BinaryExpression {
   public CommaExpression(int var1, Expression var2, Expression var3) {
      super(0, var1, var3 != null ? var3.type : Type.tVoid, var2, var3);
   }

   public Vset check(Environment var1, Context var2, Vset var3, Hashtable var4) {
      var3 = super.left.check(var1, var2, var3, var4);
      var3 = super.right.check(var1, var2, var3, var4);
      return var3;
   }

   void selectType(Environment var1, Context var2, int var3) {
      super.type = super.right.type;
   }

   Expression simplify() {
      if (super.left == null) {
         return super.right;
      } else {
         return (Expression)(super.right == null ? super.left : this);
      }
   }

   public Expression inline(Environment var1, Context var2) {
      if (super.left != null) {
         super.left = super.left.inline(var1, var2);
      }

      if (super.right != null) {
         super.right = super.right.inline(var1, var2);
      }

      return this.simplify();
   }

   public Expression inlineValue(Environment var1, Context var2) {
      if (super.left != null) {
         super.left = super.left.inline(var1, var2);
      }

      if (super.right != null) {
         super.right = super.right.inlineValue(var1, var2);
      }

      return this.simplify();
   }

   int codeLValue(Environment var1, Context var2, Assembler var3) {
      if (super.right == null) {
         return super.codeLValue(var1, var2, var3);
      } else {
         if (super.left != null) {
            super.left.code(var1, var2, var3);
         }

         return super.right.codeLValue(var1, var2, var3);
      }
   }

   void codeLoad(Environment var1, Context var2, Assembler var3) {
      if (super.right == null) {
         super.codeLoad(var1, var2, var3);
      } else {
         super.right.codeLoad(var1, var2, var3);
      }
   }

   void codeStore(Environment var1, Context var2, Assembler var3) {
      if (super.right == null) {
         super.codeStore(var1, var2, var3);
      } else {
         super.right.codeStore(var1, var2, var3);
      }
   }

   public void codeValue(Environment var1, Context var2, Assembler var3) {
      if (super.left != null) {
         super.left.code(var1, var2, var3);
      }

      super.right.codeValue(var1, var2, var3);
   }

   public void code(Environment var1, Context var2, Assembler var3) {
      if (super.left != null) {
         super.left.code(var1, var2, var3);
      }

      if (super.right != null) {
         super.right.code(var1, var2, var3);
      }

   }
}
