package sun.tools.tree;

import java.io.PrintStream;
import java.util.Hashtable;
import sun.tools.asm.Assembler;
import sun.tools.java.Environment;
import sun.tools.java.Type;

public class DeclarationStatement extends Statement {
   int mod;
   Expression type;
   Statement[] args;

   public DeclarationStatement(int var1, int var2, Expression var3, Statement[] var4) {
      super(107, var1);
      this.mod = var2;
      this.type = var3;
      this.args = var4;
   }

   Vset check(Environment var1, Context var2, Vset var3, Hashtable var4) {
      var1.error(super.where, "invalid.decl");
      return this.checkBlockStatement(var1, var2, var3, var4);
   }

   Vset checkBlockStatement(Environment var1, Context var2, Vset var3, Hashtable var4) {
      var3 = ((Statement)this).reach(var1, var3);
      Type var5 = this.type.toType(var1, var2);

      for(int var6 = 0; var6 < this.args.length; ++var6) {
         var3 = this.args[var6].checkDeclaration(var1, var2, var3, this.mod, var5, var4);
      }

      return var3;
   }

   public Statement inline(Environment var1, Context var2) {
      int var3 = 0;

      for(int var4 = 0; var4 < this.args.length; ++var4) {
         if ((this.args[var4] = this.args[var4].inline(var1, var2)) != null) {
            ++var3;
         }
      }

      if (var3 == 0) {
         return null;
      } else {
         return this;
      }
   }

   public void code(Environment var1, Context var2, Assembler var3) {
      for(int var4 = 0; var4 < this.args.length; ++var4) {
         if (this.args[var4] != null) {
            this.args[var4].code(var1, var2, var3);
         }
      }

   }

   public void print(PrintStream var1, int var2) {
      var1.print("declare ");
      super.print(var1, var2);
      this.type.print(var1);
      var1.print(" ");

      for(int var3 = 0; var3 < this.args.length; ++var3) {
         if (var3 > 0) {
            var1.print(", ");
         }

         if (this.args[var3] != null) {
            this.args[var3].print(var1);
         } else {
            var1.print("<empty>");
         }
      }

      var1.print(";");
   }
}
