package sun.tools.tree;

import sun.tools.asm.Assembler;
import sun.tools.asm.Label;
import sun.tools.java.CompilerError;
import sun.tools.java.Environment;

public class GreaterOrEqualExpression extends BinaryCompareExpression {
   public GreaterOrEqualExpression(int var1, Expression var2, Expression var3) {
      super(21, var1, var2, var3);
   }

   Expression eval(int var1, int var2) {
      return new BooleanExpression(super.where, var1 >= var2);
   }

   Expression eval(long var1, long var3) {
      return new BooleanExpression(super.where, var1 >= var3);
   }

   Expression eval(float var1, float var2) {
      return new BooleanExpression(super.where, var1 >= var2);
   }

   Expression eval(double var1, double var3) {
      return new BooleanExpression(super.where, var1 >= var3);
   }

   Expression simplify() {
      return (Expression)(super.left.isConstant() && !super.right.isConstant() ? new LessOrEqualExpression(super.where, super.right, super.left) : this);
   }

   void codeBranch(Environment var1, Context var2, Assembler var3, Label var4, boolean var5) {
      super.left.codeValue(var1, var2, var3);
      switch (super.left.type.getTypeCode()) {
         case 4:
            if (!super.right.equals(0)) {
               super.right.codeValue(var1, var2, var3);
               var3.add(super.where, var5 ? 162 : 161, var4, var5);
               return;
            }
            break;
         case 5:
            super.right.codeValue(var1, var2, var3);
            var3.add(super.where, 148);
            break;
         case 6:
            super.right.codeValue(var1, var2, var3);
            var3.add(super.where, 149);
            break;
         case 7:
            super.right.codeValue(var1, var2, var3);
            var3.add(super.where, 151);
            break;
         default:
            throw new CompilerError("Unexpected Type");
      }

      var3.add(super.where, var5 ? 156 : 155, var4, var5);
   }
}
