package sun.tools.tree;

import sun.tools.asm.Assembler;
import sun.tools.java.Environment;
import sun.tools.java.Type;

public class IntegerExpression extends ConstantExpression {
   int value;

   IntegerExpression(int var1, int var2, Type var3, int var4) {
      super(var1, var2, var3);
      this.value = var4;
   }

   public boolean fitsType(Environment var1, Context var2, Type var3) {
      switch (var3.getTypeCode()) {
         case 1:
            if (this.value != (byte)this.value) {
               return false;
            }

            return true;
         case 2:
            if (this.value != (char)this.value) {
               return false;
            }

            return true;
         case 3:
            if (this.value != (short)this.value) {
               return false;
            }

            return true;
         default:
            return super.fitsType(var1, var2, var3);
      }
   }

   public Object getValue() {
      return new Integer(this.value);
   }

   public boolean equals(int var1) {
      return this.value == var1;
   }

   public boolean equalsDefault() {
      return this.value == 0;
   }

   public void codeValue(Environment var1, Context var2, Assembler var3) {
      var3.add(super.where, 18, new Integer(this.value));
   }
}
