package sun.tools.tree;

import sun.tools.asm.Assembler;
import sun.tools.java.Environment;

public class UnsignedShiftRightExpression extends BinaryShiftExpression {
   public UnsignedShiftRightExpression(int var1, Expression var2, Expression var3) {
      super(28, var1, var2, var3);
   }

   Expression eval(int var1, int var2) {
      return new IntExpression(super.where, var1 >>> var2);
   }

   Expression eval(long var1, long var3) {
      return new LongExpression(super.where, var1 >>> (int)var3);
   }

   Expression simplify() {
      return (Expression)(!super.left.equals(0) && !super.right.equals(0) ? this : super.left);
   }

   void codeOperation(Environment var1, Context var2, Assembler var3) {
      var3.add(super.where, 124 + super.type.getTypeCodeOffset());
   }
}
